package Winxle::Admin::Controller::Campaign;
use Moose;

use Winxle::Globals;

has 'campaign_model' =>
    ( is => 'ro', isa => 'Winxle::Admin::Model::Campaign', required => 1 );

sub root_GET {
    my ( $self, $req ) = @_;

    my $conds   = {};
    my $attribs = {
        offset => $req->param('o') || 0,
        rows   => $req->param('n') || 10,
        order_by => 'created desc'
    };

    my $set = $self->campaign_model->list( $conds, $attribs );
    return $req->new_json_response($set);
}

sub item_GET {
    my ( $self, $req, $uuid ) = @_;

    my $c = $self->campaign_model->view($uuid);
    return $req->new_json_response($c);
}

sub status_PUT {
    my ( $self, $req, $uuid ) = @_;

    my $data = $req->got_json;

    try {
        $self->campaign_model->update_status( $uuid, $data );
        return $req->new_json_response( { status => 'ok' } );
    }
    catch {
        return $req->new_json_error($_);
    };
}

sub globals {
    my ( $self, $req ) = @_;

    my @types;
    return $req->new_json_response(
        {   types  => [ Winxle::Globals->available_campaign_types ],
            status => [ Winxle::Globals->available_campaign_status ],
            count  => $self->campaign_model->count,
        }
    );
}

__PACKAGE__->meta->make_immutable;
1;
