wApp.service('webService',  ['$http', '$q', function ( $http, $q ) {
    "use strict";

    var requestBASE = GLOBAL.apiUrl;

    var getHandler = function ( url, queryObject ) {
        var requestURL = requestBASE + url;

        var deferred = $q.defer();

        $('.loader').show();

        $http
            .get( requestURL, { params: queryObject })
            .success( function( data ) {
                console.log(['getRequest > ' + requestURL, data]);
                deferred.resolve( data );
                $('.loader').hide();
            })
            .error( function( err ) {
                deferred.reject( err );
                $('.loader').hide();
            }
        );

        return deferred.promise;
    },
    postHandler = function ( url, data ) {
        var requestURL = requestBASE + url;
        var deferred = $q.defer();

        if (typeof data === 'undefined') {
            console.error('"data" should not be undefined');
            return false;
        }

        $http
            .post( requestURL, data)
            .success( function( data ) {
                deferred.resolve( data );
            })
            .error( function( err ) {
                deferred.reject();
            }
        );

        return deferred.promise;
    },
    putHandler = function ( url, data ) {
        var deferred = $q.defer();
        var requestURL = requestBASE + url;

        if (typeof data === 'undefined') {
            console.error('"data" should not be undefined');
            return false;
        }

        $http
            .put( requestURL, data)
            .success( function( data ) {
                console.log("got back", data);
                deferred.resolve( data );
            })
            .error( function( err ) {
                deferred.reject();
            }
        );

        return deferred.promise;
    };

    return {
        get: getHandler,
        post: postHandler,
        put: putHandler
    };

}]);
        
// vim: expandtab
